       PROCESS DLL,EXPORTALL,TEST(NOSEP)
      *+---------------------------------------------------------------+
      *| Product: IBM Rational Developer for System z                  |
      *| Component: IBM z/OS Automated Unit Testing Framework (zUnit)  |
      *|   for Enterprise COBOL and PL/I                               |
      *| Program: Enterprise COBOL zUnit Test Case                     |
      *| Date Generated: 10/23/2014 16:42                              |
      *| ID: 4611ba62-e2e1-4567-a718-2a00fd076bc7                      |
      *+---------------------------------------------------------------+
      *+---------------------------------------------------------------+
      *| AZUTC004                                                      |
      *|     This program is immediately called by the IBM             |
      *|     z/OS Automated Unit Testing Framework (zUnit)             |
      *|     Test Runner to allow for initialization of the            |
      *|     Test Case. Upon return from this program, the             |
      *|     Test Runner will attempt to call the ADDTESTS             |
      *|     program.                                                  |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| Note: this program does not require editing.                  |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'AZUTC004'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 CBLTESTC-ID PIC X(36)
            VALUE '4611ba62-e2e1-4567-a718-2a00fd076bc7'.
       1 CBLTESTC-NAME PIC X(8)
            VALUE 'AZUTC004'.
       1 CBLTESTC-ID-LEN PIC S9(9) COMP-5.
       1 CBLTESTC-NAME-LEN PIC S9(9) COMP-5.
       1 CBLTESTC-SETUP    FUNCTION-POINTER.
       1 CBLTESTC-TEARDOWN FUNCTION-POINTER.
       1 CBLTESTC-ADDTESTS FUNCTION-POINTER.
       LINKAGE SECTION.
       1 TEST-CASE-PTR POINTER.
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR.
      *    this program does not require editing.
           MOVE LENGTH OF CBLTESTC-ID TO CBLTESTC-ID-LEN
           MOVE LENGTH OF CBLTESTC-NAME TO CBLTESTC-NAME-LEN
           SET CBLTESTC-ADDTESTS TO ENTRY 'ADDTESTS'
           SET CBLTESTC-SETUP    TO ENTRY 'SETUP'
           SET CBLTESTC-TEARDOWN TO ENTRY 'TEARDOWN'
           CALL 'AZUTCINI' USING
               BY VALUE     TEST-CASE-PTR
               BY REFERENCE CBLTESTC-ID
               BY VALUE     CBLTESTC-ID-LEN
               BY REFERENCE CBLTESTC-NAME
               BY VALUE     CBLTESTC-NAME-LEN
               BY VALUE     CBLTESTC-ADDTESTS
               BY VALUE     CBLTESTC-SETUP
               BY VALUE     CBLTESTC-TEARDOWN
           .
        END PROGRAM 'AZUTC004'.
      *+---------------------------------------------------------------+
      *| ADDTESTS                                                      |
      *|     This program is called by the zUnit Test Runner           |
      *|     to allow for adding Tests to the Test Case. Upon          |
      *|     return from this program, the Test Runner will            |
      *|     call the added Tests, surrounding each with calls         |
      *|     to the SETUP and TEARDOWN programs.                       |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'ADDTESTS'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 TEST-ENTRY     FUNCTION-POINTER.
       1 TEST-NAME      PIC X(254).
       1 TEST-NAME-LEN  PIC S9(9) COMP-5.
       LINKAGE SECTION.
       1 TEST-CASE-PTR POINTER.
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR.
      *    add tests to the test case.
           SET TEST-ENTRY TO ENTRY 'ENTRY1'
           MOVE 'ENTRY1' TO TEST-NAME
           MOVE 6 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           SET TEST-ENTRY TO ENTRY 'AZUE0000'
           MOVE 'AZUE0000' TO TEST-NAME
           MOVE 8 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           SET TEST-ENTRY TO ENTRY 'ENTRY3'
           MOVE 'ENTRY3' TO TEST-NAME
           MOVE 6 TO TEST-NAME-LEN
           CALL 'AZUTCADD' USING
               BY VALUE     TEST-CASE-PTR
               BY VALUE     TEST-ENTRY
               BY REFERENCE TEST-NAME
               BY VALUE     TEST-NAME-LEN
           .
       END PROGRAM 'ADDTESTS'.
      *+---------------------------------------------------------------+
      *| SETUP                                                         |
      *|     This program is invoked by the zUnit Test Runner          |
      *|     prior to each Test to allow for allocation of             |
      *|     resources (e.g., memory, connections) that are            |
      *|     required to create the Test Fixture.                      |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (output),                             |
      *|     A pointer-by-reference in which to store the address      |
      *|     of a user-defined structure that represents the Test      |
      *|     Fixture. References to all allocated resources should     |
      *|     be maintained in this structure so that they may be       |
      *|     accessed in the respective Test program, and released     |
      *|     in the TEARDOWN program.                                  |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'SETUP'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 CEEGTST-SIZE PIC S9(9) COMP-5.
       1 CEEGTST-HEAP PIC S9(9) COMP-5.
       1 PARM-SIZE    PIC S9(9) COMP-5.
       1 CURRENT-TEST-FIXTURE-PTR POINTER.
       1 CURRENT-TEST-FIXTURE-PTR-VALUE REDEFINES
           CURRENT-TEST-FIXTURE-PTR PIC S9(9) COMP-5.
       1 NEXT-TEST-FIXTURE-PTR POINTER.
       1 NEXT-TEST-FIXTURE-PTR-VALUE REDEFINES
           NEXT-TEST-FIXTURE-PTR  PIC S9(9) COMP-5.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       1 AZ-TEST-INPUT-DATA-VALUE.
          3 ZUT00000000.
            5 PIC X(1) DISPLAY VALUE 'N'.
          3 ZUT00000001.
            5 PIC X(1) DISPLAY VALUE 'Y'.
          3 ZUT00000002.
            5 PIC X(1) DISPLAY VALUE 'N'.
       1 AZ-TEST-NAME-FOR-SUB   PIC X(254) EXTERNAL.
       1 AZ-TEST-NAME-LEN  PIC S9(9) COMP-5 EXTERNAL.
       1 AZ-TEST-CASE-PTR  POINTER EXTERNAL.
       1 AZ-TEST-CASE-PTR-VALUE REDEFINES
           AZ-TEST-CASE-PTR  PIC 9(9) COMP-5.
       LINKAGE SECTION.
       1 CHECK-CODE PIC X(01).
         88 CHECK-TOUR-CODE VALUE 'Y'.
         88 NO-CHECK-TOUR-CODE VALUE 'N'.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-CASE-PTR-VALUE REDEFINES
           TEST-CASE-PTR  PIC 9(9) COMP-5.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY REFERENCE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           MOVE TEST-NAME(1:TEST-NAME-LEN) TO
              AZ-TEST-NAME-FOR-SUB(1:TEST-NAME-LEN)
           MOVE TEST-NAME-LEN TO AZ-TEST-NAME-LEN
           EVALUATE TEST-NAME(1:TEST-NAME-LEN)
              WHEN 'ENTRY1'
                DISPLAY 'SETUP (' TEST-NAME(1:TEST-NAME-LEN) ')'
      *       setup for test ENTRY1
                PERFORM ALLOCATE-PARM
                MOVE ZUT00000000 TO CHECK-CODE
                MOVE TEST-CASE-PTR-VALUE TO AZ-TEST-CASE-PTR-VALUE
              WHEN 'AZUE0000'
                DISPLAY 'SETUP (' TEST-NAME(1:TEST-NAME-LEN) ')'
      *       setup for test AZUE0000
                PERFORM ALLOCATE-PARM
                MOVE ZUT00000002 TO CHECK-CODE
                MOVE TEST-CASE-PTR-VALUE TO AZ-TEST-CASE-PTR-VALUE
              WHEN 'ENTRY3'
                DISPLAY 'SETUP (' TEST-NAME(1:TEST-NAME-LEN) ')'
      *       setup for test ENTRY3
                PERFORM ALLOCATE-PARM
                MOVE ZUT00000001 TO CHECK-CODE
                MOVE TEST-CASE-PTR-VALUE TO AZ-TEST-CASE-PTR-VALUE
           END-EVALUATE
           GOBACK
           .
        ALLOCATE-PARM.
      *    allocate an instance of parameter structure
           INITIALIZE CEEGTST-HEAP CEEGTST-SIZE
      *    get a parameter size
           INITIALIZE PARM-SIZE
           IF LENGTH OF CHECK-CODE > PARM-SIZE
             MOVE LENGTH OF CHECK-CODE TO PARM-SIZE
           ADD PARM-SIZE TO CEEGTST-SIZE
      *    get heap storage
           CALL 'CEEGTST' USING CEEGTST-HEAP CEEGTST-SIZE
                TEST-FIXTURE-PTR OMITTED
           SET NEXT-TEST-FIXTURE-PTR TO TEST-FIXTURE-PTR
      *    set address of a parameter
           SET ADDRESS OF CHECK-CODE TO NEXT-TEST-FIXTURE-PTR
           .
       END PROGRAM 'SETUP'.
      *+---------------------------------------------------------------+
      *| TEARDOWN                                                      |
      *|     This program is invoked by the zUnit Test Runner          |
      *|     after each Test to allow for releasing resources          |
      *|     (e.g., memory, connection) which were allocated           |
      *|     during creation of the Test Fixture in the SETUP          |
      *|     program.                                                  |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'TEARDOWN'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       LINKAGE SECTION.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
           EVALUATE TEST-NAME(1:TEST-NAME-LEN)
              WHEN 'ENTRY1'
      *         free test fixture for 'ENTRY1'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
                DISPLAY 'TEARDOWN (' TEST-NAME(1:TEST-NAME-LEN) ')'
              WHEN 'AZUE0000'
      *         free test fixture for 'AZUE0000'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
                DISPLAY 'TEARDOWN (' TEST-NAME(1:TEST-NAME-LEN) ')'
              WHEN 'ENTRY3'
      *         free test fixture for 'ENTRY3'
                CALL 'CEEFRST' USING TEST-FIXTURE-PTR OMITTED
                DISPLAY 'TEARDOWN (' TEST-NAME(1:TEST-NAME-LEN) ')'
           END-EVALUATE
           .
       END PROGRAM 'TEARDOWN'.
      *+---------------------------------------------------------------+
      *| ENTRY1                                                        |
      *|     A Test (supply more detail).                              |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'ENTRY1'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       1 PARM-SIZE        PIC S9(9) COMP-5.
       1 INVALID-NUMBER-PTR POINTER.
       LINKAGE SECTION.
       1 CHECK-CODE PIC X(01).
         88 CHECK-TOUR-CODE VALUE 'Y'.
         88 NO-CHECK-TOUR-CODE VALUE 'N'.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-FIXTURE-PTR-VALUE REDEFINES
           TEST-FIXTURE-PTR  PIC S9(9) COMP-5.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       1 INVALID-NUMBER   PIC X(31).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
       MAIN SECTION.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
      *    display test name on entry
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
      *    set address of a parameter
           SET ADDRESS OF CHECK-CODE TO TEST-FIXTURE-PTR
      *    call program to generate input file
           DISPLAY 'CALL ZUTFIN01'
           CALL 'ZUTFIN01'.
      *    call test program
           DISPLAY 'CALL TOURFILE'
           CALL 'TOURFILE'
           USING CHECK-CODE
           .
      *    call program to evaluate output file
           DISPLAY 'CALL ZUTFOT01'
           CALL 'ZUTFOT01'.
      *    display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN)
           ' Successful.'.
           GOBACK.
       THROW-ASSERTION.
      *    throw an assertion exception (ends test)
           CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                                 BY REFERENCE FAIL-MESSAGE-TXT
                                 BY VALUE FAIL-MESSAGE-LEN
           EXIT.
       END PROGRAM 'ENTRY1'.
      *+---------------------------------------------------------------+
      *| AZUE0000                                                      |
      *|     A Test (supply more detail).                              |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'AZUE0000'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       1 PARM-SIZE        PIC S9(9) COMP-5.
       1 INVALID-NUMBER-PTR POINTER.
       LINKAGE SECTION.
       1 CHECK-CODE PIC X(01).
         88 CHECK-TOUR-CODE VALUE 'Y'.
         88 NO-CHECK-TOUR-CODE VALUE 'N'.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-FIXTURE-PTR-VALUE REDEFINES
           TEST-FIXTURE-PTR  PIC S9(9) COMP-5.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       1 INVALID-NUMBER   PIC X(31).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
       MAIN SECTION.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
      *    display test name on entry
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
      *    set address of a parameter
           SET ADDRESS OF CHECK-CODE TO TEST-FIXTURE-PTR
      *    call program to generate input file
           DISPLAY 'CALL ZUTFIN01'
           CALL 'ZUTFIN01'.
      *    call test program
           DISPLAY 'CALL TOURFILE'
           CALL 'TOURFILE'
           USING CHECK-CODE
           .
      *    call program to evaluate output file
           DISPLAY 'CALL ZUTFOT01'
           CALL 'ZUTFOT01'.
      *    display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN)
           ' Successful.'.
           GOBACK.
       THROW-ASSERTION.
      *    throw an assertion exception (ends test)
           CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                                 BY REFERENCE FAIL-MESSAGE-TXT
                                 BY VALUE FAIL-MESSAGE-LEN
           EXIT.
       END PROGRAM 'AZUE0000'.
      *+---------------------------------------------------------------+
      *| ENTRY3                                                        |
      *|     A Test (supply more detail).                              |
      *|                                                               |
      *| @param TEST-CASE-PTR (input),                                 |
      *|     A pointer-by-value to an area maintained by the           |
      *|     zUnit Test Runner that identifies the Test Case           |
      *|     and associated resources.                                 |
      *|                                                               |
      *| @param TEST-FIXTURE-PTR (input),                              |
      *|     A pointer-by-value to a user-defined structure,           |
      *|     established previously in the SETUP program, that         |
      *|     represents the Test Fixture.                              |
      *|                                                               |
      *| @param TEST-NAME-PTR (input),                                 |
      *|     A pointer-by-value to an area containing the name         |
      *|     of the Test for which a Test Fixture should be            |
      *|     allocated.                                                |
      *|                                                               |
      *| @param TEST-NAME-LEN (input),                                 |
      *|     A integer-by-value that specifies the length in           |
      *|     bytes of the value contained in parameter                 |
      *|     TEST-NAME-PTR.                                            |
      *+---------------------------------------------------------------+
       IDENTIFICATION DIVISION.
       PROGRAM-ID. 'ENTRY3'.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       1 FAIL-MESSAGE-TXT PIC X(254).
       1 FAIL-MESSAGE-LEN PIC S9(9) COMP-5.
       1 PARM-SIZE        PIC S9(9) COMP-5.
       1 INVALID-NUMBER-PTR POINTER.
       LINKAGE SECTION.
       1 CHECK-CODE PIC X(01).
         88 CHECK-TOUR-CODE VALUE 'Y'.
         88 NO-CHECK-TOUR-CODE VALUE 'N'.
       1 TEST-CASE-PTR    POINTER.
       1 TEST-FIXTURE-PTR POINTER.
       1 TEST-FIXTURE-PTR-VALUE REDEFINES
           TEST-FIXTURE-PTR  PIC S9(9) COMP-5.
       1 TEST-NAME-PTR    POINTER.
       1 TEST-NAME-LEN    PIC S9(9) COMP-5.
       1 TEST-NAME        PIC X(254).
       1 INVALID-NUMBER   PIC X(31).
       PROCEDURE DIVISION USING BY VALUE TEST-CASE-PTR
                          BY VALUE TEST-FIXTURE-PTR
                          BY VALUE TEST-NAME-PTR
                          BY VALUE TEST-NAME-LEN.
       MAIN SECTION.
           SET ADDRESS OF TEST-NAME TO TEST-NAME-PTR
      *    display test name on entry
           DISPLAY TEST-NAME(1:TEST-NAME-LEN) ' Started...'
      *    establish addressability to test fixture
      *    set address of a parameter
           SET ADDRESS OF CHECK-CODE TO TEST-FIXTURE-PTR
      *    call program to generate input file
           DISPLAY 'CALL ZUTFIN01'
           CALL 'ZUTFIN01'.
      *    call test program
           DISPLAY 'CALL TOURFILE'
           CALL 'TOURFILE'
           USING CHECK-CODE
           .
      *    call program to evaluate output file
           DISPLAY 'CALL ZUTFOT01'
           CALL 'ZUTFOT01'.
      *    display test name on exit
           DISPLAY TEST-NAME(1:TEST-NAME-LEN)
           ' Successful.'.
           GOBACK.
       THROW-ASSERTION.
      *    throw an assertion exception (ends test)
           CALL 'AZUASTFM' USING BY VALUE TEST-CASE-PTR
                                 BY REFERENCE FAIL-MESSAGE-TXT
                                 BY VALUE FAIL-MESSAGE-LEN
           EXIT.
       END PROGRAM 'ENTRY3'.